/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * ArrowTreeModel.h
 *  Created on: 17.11.2009
 */

#ifndef ARROWTREEMODEL_H_
#define ARROWTREEMODEL_H_

#include <QAbstractItemModel>
#include <QModelIndex>
#include <QVariant>
#include "Pfeil.h"
#include "UnitConverter.h"

#include "TreeItem.h"
//#include "TreeItem.cpp"
//class ArrowTreeItem;


class ArrowTreeModel: public QAbstractItemModel {
Q_OBJECT

public:
	ArrowTreeModel(QObject *parent = 0);
	~ArrowTreeModel();

	QVariant data(const QModelIndex &index, int role) const;
	Qt::ItemFlags flags(const QModelIndex &index) const;
	QVariant headerData(int section, Qt::Orientation orientation, int role =
			Qt::DisplayRole) const;
	QModelIndex index(int row, int column, const QModelIndex &parent =
			QModelIndex()) const;
	QModelIndex parent(const QModelIndex &index) const;
	int rowCount(const QModelIndex &parent = QModelIndex()) const;
	int columnCount(const QModelIndex &parent = QModelIndex()) const;
	bool removeRow ( int row, const QModelIndex & parent = QModelIndex() );
	bool removeRows ( int row, int count, const QModelIndex & parent = QModelIndex() );
	bool insertRow ( int row, const QModelIndex & parent = QModelIndex() );
	bool insertRows ( int row, int count, const QModelIndex & parent = QModelIndex() );

	TreeItem<CPfeil> *rootItem;
	std::list<CPfeil> m_list;
	UnitConverter *m_unitconverter;
    void clear();

//private:
	bool  create_data(TreeItem<CPfeil> *child, TreeItem<CPfeil> *parent, CPfeil *base_item, const QMap<QString, QVariant> &v);

	void write_item(int &depth, TreeItem<CPfeil> *item);


    CPfeil* getItem(QModelIndex index);
    bool setItem(QModelIndex index, CPfeil &a);
    bool setItem(CPfeil &a);
    bool appendRow(CPfeil &a);



};

#endif /* ARROWTREEMODEL_H_ */
