/***************************************************************************
 *   Copyright (C) 2011 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * GraphicsOrthoLineItem.cpp
 *  Created on: 04.01.2011
 */

#include "GraphicsOrthoLineItem.h"

GraphicsOrthoLineItem::GraphicsOrthoLineItem(QGraphicsItem * parent ) : QGraphicsLineItem(parent) {
	// TODO Auto-generated constructor stub
	direction = GraphicsOrthoLineItem::horizontal;
	number = 0;
	PenSelected = new QPen(QColor("red"));
	PenSelected->setWidth(3);
	PenSelected->setStyle( Qt::SolidLine);
	PenNormal = new QPen(QColor("black"));
	PenNormal->setWidth(3);
	PenNormal->setStyle( Qt::SolidLine);
	marked = false;

}

GraphicsOrthoLineItem::~GraphicsOrthoLineItem() {
	// TODO Auto-generated destructor stub
}
void GraphicsOrthoLineItem::setLine(qreal x1, qreal y1, qreal xy2, Direction dir) {
	qreal x2;
	qreal y2;
	direction = dir;

	if(dir == GraphicsOrthoLineItem::horizontal) {
		x2 = xy2;
		y2 = y1;
	}else {
		y2 = xy2;
		x2 = x1;
	}
	QGraphicsLineItem::setLine(x1,y1,x2,y2);
	QGraphicsLineItem::setPen(*PenNormal);

}
void GraphicsOrthoLineItem::markAsSelected(bool selected) {
	if(selected) {
		QGraphicsLineItem::setPen(*PenSelected);
		QGraphicsLineItem::setZValue(1.0);
		marked = true;
	}else {
		QGraphicsLineItem::setPen( *PenNormal);
		QGraphicsLineItem::setZValue(0.0);
		marked = false;
	}
	//update();


}
