/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef Pfeil_h
#define  Pfeil_h

#include <stdlib.h>
#include <ballistic/ballistic.h>
#include <QString>
#include <QUuid>
#include <QMap>
#include <QVariant>
#include <QDomDocument>
#include "Datastore.h"

using namespace arw;

/**
Massenträgheitsmoment J über den Schwerpunkt
http://de.wikipedia.org/wiki/Physisches_Pendel

Gamegetter 2216
Schaftlänge= 0.502 m
Masse vom Pfeil m= 0.02766 kg
Erdbeschl. g = 9.81 m/s²
Masse von der Spitze: 125 grain = 8.1 g = 0.0081 kg
Abstand der Spitze vom Schwerpunkt: 0.18 m
Vanes Abstand vom Schwerpunkt: 0.270
Nocke Abstand vom Schwerpunkt: 0.33
cp = -0.075 m



mit Draht an der Nocke aufgehängt
Schwerpunktsabstand a = 0.340 m
Schwingungsdauer T= 1.33333 s
J = 0.000955

mit Draht an der Spitze aufgehängt
Schwerpunktsabstand a = 0.199 m
Schwingungsdauer T= 1.22449 s
J = 0.0009557

Formel, der Letzte Teil der Formel ist der Steineranteil (m*a²)
J= T*T*m*g*a / (4*%pi*%pi) - m*a*a


 */
class CPfeil : public arrow, public Datastore
{


protected:

public:
    CPfeil();  //Constructor
    CPfeil(const CPfeil &p);
    CPfeil(const QString guid);


/**

	<map name="data">
			<double name="hallo">
				1.343
			</double>
			<string name="test">
				hallo ein Test
			</string>
			<map name="vector">
				<double name="x">
					3.4
				</double>
				<double name="y">
					4.56
				</double>
				<double name="z">
					4.3
				</double>
			</map>

	</map>



*/


	virtual CPfeil & take_data(const CPfeil & p);
	virtual bool setValue(QString path, QVariant value);
	void init();

	QString toString();
	int toDomElement(QDomElement &dom_arrow);
	int fromDomElement(const QDomElement &dom_arrow);
	int fromString(const QString xmlstr );
protected:


};



#endif

