/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ARROWMATCHERVIEW_H
#define ARROWMATCHERVIEW_H

#include "Armbrust.h"
#include "visier_diagram.h"
#include "view.h"

class sight_diagram_y;
class sight_diagram_z;
class ArrowmatcherDoc;

/**
 *
 * @author Herbert Roider
 */
class ArrowmatcherView: public QWidget, public View {
Q_OBJECT
public:
	/** Constructor for the main view */
	ArrowmatcherView(QWidget *parent = 0);
	/** Destructor for the main view */
	~ArrowmatcherView();
	void addView(MainWindow* mainwindow);

	/** returns a pointer to the document connected to the view instance. Mind that this method requires a ArrowmatcherApp instance as a parent
	 * widget to get to the window document pointer by calling the ArrowmatcherApp::getDocument() method.
	 *
	 * @see ArrowmatcherApp#getDocument
	 */
	ArrowmatcherDoc *getDocument() const;

	/** contains the implementation for printing functionality */
	void print(QPrinter *pPrinter);

	/**  */
	ArrowmatcherDoc* m_doc;
	virtual void update(ArrowmatcherDoc *doc);

signals:
	void valueChanged(ArrowmatcherView *);

private:

protected:
	void paintEvent(QPaintEvent *);



	int zeichnen(QPainter &dc, QRect &Rechteck);//Das Rechteck sollte ein Quadrat sein fr das Absehen.

	double m_pan;//verschiebung des Bildausschnittes in der Vertikalen
	double m_zoom;//Vergr�erungsfaktor fr das Bild (nur das Absehen!)

	double m_dEntfernung;
	double m_dZielwinkel;
	QRect m_Rechteck;
	/** buffer for the graphic output, for double buffering*/
	QPixmap *m_Pixmap;
	/** pointer to the document */
	int m_fontheight;

	sight_diagram_y * m_vd;
	sight_diagram_z * m_bd;

	QAction* actPrint;
public slots:
	void on_actPrint_triggered();

};

#endif // ARROWMATCHERVIEW_H

