/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "berechnespindelsteigungdlg.h"

#include <QMessageBox>
#include <qtextstream.h>
#include <QLabel>
#include <QLineEdit>
#include <QPushButton>

BerechneSpindelsteigungDlg::BerechneSpindelsteigungDlg( BerechneSpindelsteigungDlg::direction dir, QWidget *parent, Qt::WFlags f)
         : QDialog(parent,f) {

     ui.setupUi(this);
    connect(ui.cmdBerechnen, SIGNAL(clicked()), this, SLOT(cmdBerechnen_click()));
    this->m_direction = dir;
    if(this->m_direction == BerechneSpindelsteigungDlg::horizontal)
    {
    	ui.lblSymbol->setText("Z");

    }else{
     	ui.lblSymbol->setText("Y");

    }
	QPixmap *image = new QPixmap(":/images/targetpoint.png");
	ui.lblImage->setPixmap(*image);
}
BerechneSpindelsteigungDlg::~BerechneSpindelsteigungDlg(){
}
void BerechneSpindelsteigungDlg::cmdBerechnen_click(){
	double dEntfernung;
	double dAbweichung_1;
	double dAbweichung_2;
	double dEinstellwert_1;
	double dEinstellwert_2;
	QString s;
	QTextStream ergebnis(&s);

	dEntfernung =   ui.txtEntfernung->text().toDouble();
	dAbweichung_1 =   ui.txtAbweichung_1->text().toDouble();
	dAbweichung_2 =   ui.txtAbweichung_2->text().toDouble();
	dEinstellwert_1 =   ui.txtEinstellwert_1->text().toDouble();
 	dEinstellwert_2 =   ui.txtEinstellwert_2->text().toDouble();

	if(dEntfernung == 0)
	{
	    QMessageBox::information(this, tr("Error"),
                       tr("The range must not be 0") );
		return;
	}
	if(dEinstellwert_1 == dEinstellwert_2)
	{
	    QMessageBox::information(this, tr("Error"),
                       tr("The adjustment-values must not be equal") );
		return;
	}

	//umrechnen in m/m:
	dAbweichung_1 /= 1000.0;
	dAbweichung_2 /= 1000.0;
	dAbweichung_1 = dAbweichung_1 / dEntfernung;
	dAbweichung_2 = dAbweichung_2 / dEntfernung;

	m_slope = (dAbweichung_2 - dAbweichung_1) / (dEinstellwert_2 - dEinstellwert_1);//m/m je Teilstrich

    ergebnis << tr("The angle of 1 mark is") << " (mm/m): "
	        << QString().sprintf("%03.4f", (m_slope * 1000.0) ) << endl;

    ui.lblErgebnis->setText(s );


}
void BerechneSpindelsteigungDlg::accept(){
	QDialog::accept();
}



