/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "calc_energy_from_velocitydlg.h"
#include "UnitConverter.h"

Calc_Energy_from_VelocityDlg::Calc_Energy_from_VelocityDlg(ArrowTreeModel *p, CArmbrust &a, QWidget *parent)
     : QDialog(parent) , m_Armbrust(a) {

    ui.setupUi(this);
    m_tempArmbrust = m_Armbrust;
    m_arrow_list_model = p;
    ui.lstPfeilliste->setModel(m_arrow_list_model);
    ui.lstPfeilliste->setSelectionMode( QAbstractItemView::SingleSelection );
    ui.lstPfeilliste->setSelectionBehavior(QAbstractItemView::SelectRows);
 	ui.txtVelocity->setValue(0.0, "SI_metre_per_second", NULL, UnitInputWidget::user);
   connect(ui.cmdBerechnen, SIGNAL(clicked()), this, SLOT(cmdBerechnen_click()));
}
Calc_Energy_from_VelocityDlg::~Calc_Energy_from_VelocityDlg(){
}
void Calc_Energy_from_VelocityDlg::cmdBerechnen_click() {
 	QString str;
 	//Unit speed_unit;
 	str =   ui.txtVelocity->text();
 	bool ok;
 	double dVelocity = ui.txtVelocity->getSIValue(ok);
    double dEnergy;

    QItemSelectionModel *selection_model = ui.lstPfeilliste->selectionModel ();
    if(selection_model == NULL){
        QMessageBox::information(this, tr("Error"),
                       tr("select an arrow") );//MessageBox("einen Pfeil aus der Pfeilliste ausw�len!", "Arrowmatcher", MB_ICONEXCLAMATION);
        return;
    }
    QModelIndex index = selection_model->currentIndex();


    CPfeil *ptrPfeil = m_arrow_list_model->getItem(index);//= ui.lstPfeile->GetSelPfeil();
    if(ptrPfeil == NULL)
    {
        QMessageBox::information(this, tr("Error"),
                       tr("select an arrow") );//MessageBox("einen Pfeil aus der Pfeilliste ausw�len!", "Arrowmatcher", MB_ICONEXCLAMATION);
        return;
    }
    if(dVelocity <= 0.0) {
   	    QMessageBox::information(this, tr("Error"),
                       tr("Velocity must not be zero") );
		return ;
	}

    dEnergy =  dVelocity * dVelocity * ptrPfeil->m / 2.0;
    UnitConverter uv;
	QString unitstr = m_tempArmbrust.getValue("energy/unit").toString();
	int status = m_tempArmbrust.getValue("energy/status").toInt();
	double v = dEnergy;
	uv.convert_from_SI(v, unitstr);
	m_tempArmbrust.setValue("energy/status", (int)Datastore::user );
	m_tempArmbrust.setValue("energy/value", v);

	Ergebnis_ausgeben();
}
void Calc_Energy_from_VelocityDlg::accept() {


	//if(Ergebnis_ausgeben() == 0)
	m_Armbrust = m_tempArmbrust;
	QDialog::accept();


}

/** No descriptions */
int Calc_Energy_from_VelocityDlg::Ergebnis_ausgeben(){
	//std::ostringstream strstrAusgabe;
    QString s;
    QTextStream strstrAusgabe(&s);
    Unit u;
    UnitConverter unitconv;
    unitconv.get_unit(u, m_tempArmbrust.getValue(QString("energy/unit")).toString());
    strstrAusgabe << tr("Energy") << "<b><font color=red>"
				<< m_tempArmbrust.getValue(QString("energy/value")).toDouble() << QString(" ") << u.m_symbol << "</font></b>" << endl;
	ui.txtAusgabe->setText(s );
	return 0;
}








