/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CALC_VELOCITY_DLG_H
#define CALC_VELOCITY_DLG_H

#include <QtGui/QDialog>
#include "ui_calc_velocity_dlg.h"
#include "Armbrust.h"
#include "ArrowTreeModel.h"


class calc_velocity_dlg : public QDialog
{
    Q_OBJECT

public:
    calc_velocity_dlg(QWidget *parent = 0);
    ~calc_velocity_dlg();
    void init(CArmbrust &a, ArrowTreeModel *p );
    CArmbrust m_crossbow;
protected slots:

  virtual void on_cmdCalc_clicked();
  //void reject();


protected:
    Ui::calc_velocity_dlg ui;
    ArrowTreeModel *m_arrow_list_model;
    CPfeil m_arrow;
    utility::vector_3d m_devitation_small;
    utility::vector_3d m_devitation_wide;
    void accept();
    void set_values(CArmbrust &a);
    void get_values(CArmbrust &a);
    void print_result(CArmbrust &a, CPfeil &p);
};

#endif // CALC_VELOCITY_DLG_H
