/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CROSSBOWS_ARROWS_SETTINGSDLG_H
#define CROSSBOWS_ARROWS_SETTINGSDLG_H


#include "Armbrust.h"
#include "Pfeil.h"
#include "arrowmatcherdoc.h"
//#include <QItemSelectionModel>
//#include "mainwindow.h"
/**
 *@author Herbert Roider
 */

class crossbow_list_model;
class arrow_list_model;
class QTableView;
class QPushButton;
class QLabel;
class QLineEdit;
class QTreeView;
class UnitInputWidget;
//class QItemSelectionModel;
//class QModelIndex;

class crossbows_arrows_settingsdlg: public QWidget, public View {
Q_OBJECT
public:
	crossbows_arrows_settingsdlg(QWidget *parent = 0);
	~crossbows_arrows_settingsdlg();


	/** must call bevor show or exec !*/
	void addView(MainWindow* mainwindow);
	virtual void update(ArrowmatcherDoc *doc);

	QPushButton *cmd_Ok;
	//QTableView *lstArmbruste;
	QTableView *lstPfeilliste;
	QTreeView *trvArrowlist;
	QTreeView *trvCrossbowlist;

	UnitInputWidget *txtEntfernung;
	UnitInputWidget *txtZielwinkel;
	UnitInputWidget * txtWindSpeed;
	UnitInputWidget * txtWindAngle;
	QLabel *lblRange;
	QLabel *lblWindspeed;


	QMenu *popup_arrowlist;
	QMenu *popup_crossbowlist;

	QAction* action_Crossbow_new;
	QAction* action_Crossbow_edit;
	QAction* action_Crossbow_delete;
	QAction* action_Crossbow_copy;
	QAction* action_Crossbow_paste;

	QAction* action_Arrow_new;
	QAction* action_Arrow_edit;
	QAction* action_Arrow_delete;
	QAction* action_Arrow_copy;
	QAction* action_Arrow_paste;

protected:
	void SetBackgroundImage(QWidget *fp_widget, const QPixmap *fp_image);
	/**  */
	ArrowmatcherDoc * m_pdoc;


public slots:

	void cmdOk_click();
	void showCrossbowListItemMenu(const QPoint &pos);
	void showArrowListItemMenu(const QPoint &pos);

	//void on_lstPfeilliste_selectionChanged (const QItemSelection &selected, const QItemSelection &deselected );
	void on_lstPfeilliste_currentChanged ( const QModelIndex &current, const QModelIndex &previous );
	void on_lstArmbrustliste_currentChanged ( const QModelIndex &current, const QModelIndex &previous );
	void slotModifyCurrentArrow();
	void slotModifyCurrentCrossbow();

};
#endif
