/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 *  Created on: 28.10.2009
 */

#ifndef DLGARROWTABDIMENSIONS_H
#define DLGARROWTABDIMENSIONS_H

#include <QtGui/QWidget>
#include "ui_dlgarrowtabdimensions.h"
#include "DlgArrowTabUpdateable.h"
#include "DlgArrowModel.h"

class DlgArrowModel;


class DlgArrowTabDimensions: public QWidget, public DlgArrowTabUpdateable {
Q_OBJECT

public:


	DlgArrowTabDimensions(QWidget *parent = 0);
	~DlgArrowTabDimensions();

	void update(CPfeil *arrow);
	void calc(CPfeil *arrow);
	void addView(DlgArrowModel *dlg);
	bool calc_diameter(double &dia, const QString shaftcode);
	bool calc_thickness(double &thickness, const QString shaftcode);
	bool calc_shaftweight(double &weight, const QString shaftcode,
			const double length);
	bool calc_shaftweight(double &weight, double dia, double thickness,
			const double length);

	bool calc_fletchesweight(double &weight, const double length);
	bool calc_fletchesarea(double &area, const double length);
	bool get_unit_id(QString &unit_id, int index, QComboBox *combo);
	bool set_unit_id(QString unit_id, QComboBox *combo);
	bool get_SI_value(double & value, const QMap<QString, QVariant> &map);
	bool set_value_from_SI(QMap<QString, QVariant> &map, double value);
	bool set_value_from_SI(QString path_to_map , double value);
	void unit_changed(QMap<QString, QVariant> &map, QComboBox *combo, int index);
	void unit_changed(QString path_to_map, QComboBox *combo, int index);

public slots:
	void on_txtShaftweight_editingFinished();
	void on_txtShaftlength_editingFinished();
	void on_txtShaftcode_editingFinished();
	void on_txtShaftdia_editingFinished();
	void on_txtShaftthickness_editingFinished();
	void on_txtShaftdisplacement_editingFinished();
	void on_txtFletchesarea_editingFinished();
	void on_txtFletcheslength_editingFinished();
	void on_txtFletchesweight_editingFinished();
	void on_txtFletchesdisplacement_editingFinished();
	void on_txtPointweight_editingFinished();
	void on_txtPointdisplacement_editingFinished();
	void on_txtNockweight_editingFinished();
	void on_txtNockdisplacement_editingFinished();
	void on_cboShaftweight_currentIndexChanged(int index);
	void on_cboShaftlength_currentIndexChanged(int index);
	void on_cboShaftdia_currentIndexChanged(int index);
	void on_cboShaftthickness_currentIndexChanged(int index);
	void on_cboShaftdisplacement_currentIndexChanged(int index);
	void on_cboFletchesarea_currentIndexChanged(int index);
	void on_cboFletcheslength_currentIndexChanged(int index);
	void on_cboFletchesweight_currentIndexChanged(int index);
	void on_cboFletchesdisplacement_currentIndexChanged(int index);
	void on_cboPointweight_currentIndexChanged(int index);
	void on_cboPointdisplacement_currentIndexChanged(int index);
	void on_cboNockweight_currentIndexChanged(int index);
	void on_cboNockdisplacement_currentIndexChanged(int index);

private:
	Ui::DlgArrowTabDimensionsClass ui;
	CPfeil *m_pArrow;
};

#endif // DLGARROWTABDIMENSIONS_H
