/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "preferences.h"
#include <QSettings>
#include "UnitConverter.h"

Preferences::Preferences(QWidget *parent)
    : QDialog(parent)
{
	ui.setupUi(this);
	UnitConverter uc;
	QList<UnitSystem> list = uc.get_list_UnitSystem();
	for(int i=0; i<list.count(); i++) {
		ui.cboUnitsystem->addItem(list.at(i).m_name,(int)list.at(i).m_system);
	}
	ui.cboUnitsystem->setCurrentIndex( ui.cboUnitsystem->findData( 0 ) );//0 = metric system
}

Preferences::~Preferences()
{

}
void Preferences::init()
{
	set_values();

}
void Preferences::accept() {
	get_values();
	QDialog::accept();
}
void Preferences::set_values()
{
	QSettings settings;

	m_path2gnuplot = settings.value("path2gnuplot").value<QString> () ;
	ui.txtPath2gnuplot->setText(m_path2gnuplot);

	m_language = settings.value("language").value<QString> () ;
	ui.txtLanguage->setText(m_language);

	this->m_unitsystem = settings.value("unitsystem").value<int> ();
	ui.cboUnitsystem->setCurrentIndex( ui.cboUnitsystem->findData(this->m_unitsystem) );

}
void Preferences::get_values()
{
	QSettings settings;

	m_path2gnuplot = ui.txtPath2gnuplot->text();
	m_path2gnuplot.trimmed();
	settings.setValue("path2gnuplot", m_path2gnuplot);

	m_language = ui.txtLanguage->text();
	m_language.trimmed();
	m_language.truncate(2);
	m_language.toLower();
	settings.setValue("language", m_language);

	this->m_unitsystem = ui.cboUnitsystem->itemData(ui.cboUnitsystem->currentIndex()).toInt();
	settings.setValue("unitsystem", this->m_unitsystem);


}
