/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * sight_diagram_z.cpp
 *  Created on: 08.08.2009
 */

#include "sight_diagram_z.h"
// application specific includes
#include "arrowmatcherdoc.h"
#include "Armbrust.h"
#include <QMenu>

// include files for Qt
#include <QPainter>

#include <QTextStream>
#include <QVector>
#include <QMouseEvent>
#include <QPaintEvent>

#include <vector>
#include <list>
#include <string>
#include <QRegion>
#include <QMessageBox>
#include <iostream>
#include <stdio.h>
#include <QLayout>
#include <algorithm>
#include <map>
#include <ballistic/utility.h>
#include "sightdiagram_appearancedlg.h"

// Für zeitmessung:
#include <time.h>
#include <iostream>

#include "aspline.h"
sight_diagram_z::sight_diagram_z(QWidget *parent) :
	visier_diagram(parent) {

}

sight_diagram_z::~sight_diagram_z() {

}
int sight_diagram_z::draw_sight_scale(QPainter &dc) {
	//dc.setWindow(0,0,100,100);
	//dc.translate(100.0, 100.0);
	//dc.scale(0.5, 0.5);
	//dc.translate(0.0, 0.0);
	ArrowmatcherDoc *doc = getDocument();
	if (doc == NULL) {
		return 1;
	}
	double dEntfernung;
	int iFehler;
	double dEinstellwert;
	//const double m_pan_y = 0.0;//5.0;// 2 vertikale verschiebung nach unten in Bildschirmdkoordinaten
	//vector<double> vectRaster;
	double dIntervall;

	QString s;

	QPen originalPen = dc.pen();
	QFont originalFont = dc.font();
	QBrush originalBrush = dc.brush();
	QFont fontLabelAxis("courier", m_fontheight, QFont::Light);//Beschriftung der beiden Achsen

	QBrush transparentBrush(Qt::NoBrush);
	QPen Absehen(QColor("DarkGrey"), 0, Qt::SolidLine);
	QPen RangeMark(QColor("green"), 0, Qt::SolidLine);// "ForestGreen"
	QPen senkrechteRaster(QColor("LightGrey"), 0, Qt::SolidLine); //helles Grau
	QPen Kurve(QColor("red"), 0, Qt::SolidLine);
	QPen Schriftstift(QColor("black"), 0, Qt::SolidLine);
	QPen red_dash(QColor("red"), 0, Qt::DotLine);
	QPen pen_max_range_mark(QColor("magenta"), 3, Qt::SolidLine);
	QPen pen_Crosshair(QColor("black"), 2, Qt::SolidLine);
	//QBrush      brush_PaleGreen
	QPoint P1;
	QPoint P2;

	QRect test;
	QRect textlabel;//for the values of the diagram-axis

	dc.setPen(Absehen);
	textlabel.setWidth(m_window_area.width() - m_diagram_area.width() - 20);
	double zero_bar_y;
	zero_bar_y = y2diagram(0.0);

	if (doc->m_Crossbow.m_Zielgeraet.m_iTyp == KIMME_U_KORN) {
		textlabel.setHeight(dc.fontMetrics().height());// Values for the vertical-axis
		bool drawlabel;
		utility::vector_3d graduation =
				doc->m_Crossbow.m_Zielgeraet.m_graduation;
		//dSpindelsteigung =  doc->m_Crossbow.m_Zielgeraet.dGetSpindelsteigung();

		// This (10/dFactor_y) should be 3.3 if dFactor = 3.3approximatly
		//dIntervall = fabs( (10.0/dFactor_y) / dSpindelsteigung);//je kleiner die Steigung, desto gr�er die Unterteilung
		dIntervall = fabs(((textlabel.height() / 2.0) / (m_dFactor_y
				* graduation.z * 1000.0)));//je kleiner die Steigung, desto gr�er die Unterteilung
		this->calc_interval(dIntervall);

		//von oben nach unten:
		drawlabel = false;
		for (dEinstellwert = 0.0; dEinstellwert < 1000000000.0; dEinstellwert
				+= dIntervall) {
			drawlabel = (!drawlabel);
			QString text;

			P1.setX(m_diagram_area.left());
			P2.setX(m_diagram_area.right());
			P1.setY(y2diagram(doc->m_Crossbow.m_Zielgeraet.m_graduation.z
					* dEinstellwert));

			// Skala geht nach unten:
			if(zero_bar_y < P1.y() ) {
				if (P1.y() > m_diagram_area.bottom() - 10.0)//ganz unten angekommen
					break;
			} else {
				if (P1.y() < m_diagram_area.top() + 10.0)
					break;
			}

			P2.setY(P1.y());
			if (!drawlabel)
				Absehen.setStyle(Qt::DotLine);
			else
				Absehen.setStyle(Qt::SolidLine);
			dc.setPen(Absehen);
			//dc.moveTo(P1);
			dc.drawLine(P1, P2);
			if (drawlabel) {

				dc.setPen(Schriftstift);
				textlabel.moveCenter(QPoint(m_diagram_area.left()
						- textlabel.width() / 2, P1.y()));
				//text.setNum(dEinstellwert,'g',5);
				//text.sprintf("%15g",dEinstellwert);
				//text.arg(dEinstellwert);
				text.setNum(dEinstellwert, 'g', 10);
				//dc.drawRect(textlabel);
				dc.drawText(textlabel, Qt::AlignRight, text);
			}
		}
		//von unten hinauf:
		drawlabel = false;
		for (dEinstellwert = 0.0; fabs(dEinstellwert) < 1000000000.0; dEinstellwert
				-= dIntervall) {
			drawlabel = (!drawlabel);
			QString text;
			P1.setX(m_diagram_area.left());
			P2.setX(m_diagram_area.right());
			P1.setY(y2diagram(doc->m_Crossbow.m_Zielgeraet.m_graduation.z
					* dEinstellwert));

			// Skala geht nach unten:
			if(zero_bar_y < P1.y() ) {
				if (P1.y() > m_diagram_area.bottom() - 10.0)//ganz unten angekommen
					break;
			} else {
				if (P1.y() < m_diagram_area.top() + 10.0)
					break;
			}

			P2.setY(P1.y());
			if (!drawlabel)
				Absehen.setStyle(Qt::DotLine);
			else
				Absehen.setStyle(Qt::SolidLine);
			dc.setPen(Absehen);
			//dc.moveTo(P1);
			dc.drawLine(P1, P2);

			if (drawlabel) {

				dc.setPen(Schriftstift);
				textlabel.moveCenter(QPoint(m_diagram_area.left()
						- textlabel.width() / 2, P1.y()));
				//text.setNum(dEinstellwert,'g',5);
				text.setNum(dEinstellwert, 'g', 10);
				//text.sprintf("%15g",dEinstellwert);
				//text.arg(dEinstellwert);
				//dc.drawRect(textlabel);
				dc.drawText(textlabel, Qt::AlignRight, text);
			}
		}

		s = tr("horizontal Sight Setting [Clicks]");
		dc.setPen(Schriftstift);

		dc.translate(m_window_area.left(), m_window_area.bottom());// origin is at left-bottom-corner
		test = QRect(0, 0, m_diagram_area.height(), 20);
		dc.rotate(-90);
		dc.fillRect(test, QBrush(QColor("yellow")));
		dc.drawText(test, Qt::AlignCenter, s);
		dc.rotate(90);
		dc.translate(-m_window_area.left(), -m_window_area.bottom());

	} else //Zeilfernrohr
	{

		utility::vector_3d sight_setting;
		QRect textlabel_range;
		QRect textlabel_devitation;
		textlabel_range.setHeight(dc.fontMetrics().height());
		textlabel_range.setWidth(textlabel.width());
		textlabel_devitation.setHeight(dc.fontMetrics().height());
		textlabel_devitation.setWidth(100);

		QVector<double> marks;
		unsigned int iRasternummer;
		// write the values in a sortable list:
		for (iRasternummer = 0; iRasternummer
				< doc->m_Crossbow.m_Zielgeraet.m_marks.size(); iRasternummer++)
		{
			marks.push_back(doc->m_Crossbow.m_Zielgeraet.m_marks[iRasternummer].z / doc->m_Crossbow.m_Zielgeraet.m_marks[iRasternummer].x);
		}
		qSort(marks.begin(), marks.end(),  qGreater<double>());


		for (iRasternummer = 0; iRasternummer
				< marks.size(); iRasternummer++) ////Querbalken mit Entfernungsangabe zeichnen
		{

			textlabel.setHeight(dc.fontMetrics().lineSpacing() * 2);// Values for the vertical-axis
			textlabel.setWidth(70);
			s = "";
			QString s1 = "";
			sight_setting.x = 1.0;
			sight_setting.z = marks[iRasternummer];
			sight_setting.y = 0.0;

			P1.setX(m_diagram_area.left());
			P2.setX(m_diagram_area.right());
			P1.setY(y2diagram(y_setting(sight_setting)));

			P2.setY(P1.y());

			if (P1.y() < m_diagram_area.top())//ganz oben angekommen
				continue;
			if (P1.y() > m_diagram_area.bottom() - 10.0)
				continue;

			dc.setPen(pen_Crosshair);
			//dc.moveTo(P1);
			dc.drawLine(P1, P2);

		}

		s = tr("vertical crosshairs");
		dc.setPen(Schriftstift);

		dc.translate(m_window_area.left(), m_window_area.bottom());// origin is at left-bottom-corner
		test = QRect(0, 0, m_diagram_area.height(), 20);
		dc.rotate(-90);
		dc.fillRect(test, QBrush(QColor("yellow")));
		dc.drawText(test, Qt::AlignCenter, s);
		dc.rotate(90);
		dc.translate(-m_window_area.left(), -m_window_area.bottom()); //os.str("");
	}
	dc.setPen(originalPen);
	dc.setBrush(originalBrush);
	dc.setFont(originalFont);
	return 0;

}
double sight_diagram_z::y2diagram(double setting) {
	/** @ todo m_pan_y sollte nur einmal bei recreate berechnet werden!!
	 * der bedingte Ausdruck muss jedes mal ausgeführt werden, weil m_pan_y auch wirklich 0 sein kann, und das macht dann Probleme.
	 */
	if (m_pan_y == 10.0e999) {
		flight_snapshot endparam, beginparam;
		utility::vector_3d center_setting;
		int iFehler = getDocument()->m_Crossbow.sight_setting(center_setting,
				endparam, beginparam, getDocument()->m_Range, m_fp);
		center_setting /= center_setting.x;
		m_pan_y = m_dFactor_y * (1000.0) * center_setting.z;
	}
	return m_dFactor_y * setting * (-1000.0) + m_pan_y + m_diagram_area.top()
			+ m_diagram_area.height() / 2.0;
}
double sight_diagram_z::y2diagram(utility::vector_3d setting) {
	return y2diagram(setting.z);
}
double sight_diagram_z::y_setting(utility::vector_3d setting) {
	return setting.z;
}
