/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/**
  *@author Herbert Roider
  */


#ifndef SIGHTDIAGRAM_APPEARANCEDLG_H
#define SIGHTDIAGRAM_APPEARANCEDLG_H

#include <qwidget.h>
#include "ui_sightdiagram_appearancedlg_base.h"
#include <vector>
#include <QListWidget>
#include <QListWidgetItem>

class sightdiagram_appearanceDlg :  public QDialog  {
   Q_OBJECT
protected:
    std::vector <double> *m_ptrAnglelist;
    std::vector <double> *m_ptrTargetcirclelist;
    double *m_ptrMax_angle;
    double *m_ptrMax_range;
    void accept();
public:
	sightdiagram_appearanceDlg(QWidget *parent=0);
	~sightdiagram_appearanceDlg();
    bool init(std::vector<double> *targetcirclelist,
                 std::vector<double> *anglelist,
                 double &max_range,
                 double &max_angle);

public slots:
    void cmdNewAngle_click();
    void cmdDeleteAngle_click();
    void lstTargetcircle_click(QModelIndex *);
    void txtTargetcircle_change(const QString &);
    void cmdCancel_click();
    void cmdDeleteTargetcircle_click();
    void cmdNewTargetcircle_click();
    void lstAngle_click(QModelIndex *);
    void txtAngle_change(const QString &);
private:
    Ui::sightdiagram_appearanceDlg_base ui;
};

#endif


